// 230501

`default_nettype none
module Decoder7seg #(
	parameter COMMON_CATHODE = 1	// 1 - common cathode, 0 - common anode
)(
	input wire		  Enable_i,		// 1 - on, 0 - off
	input wire	[3:0] Data_i,		// 4-bit input
	output wire	[6:0] Segments_o	// Connect to segment LEDs
);
	
	reg		[6:0] Temp_r;
	
	always @(*) begin
		if(Enable_i)
			case(Data_i)		     // gfedcba
				4'h0:		Temp_r = 7'b0111111;
				4'h1:		Temp_r = 7'b0000110;
				4'h2:		Temp_r = 7'b1011011;
				4'h3:		Temp_r = 7'b1001111;
				4'h4:		Temp_r = 7'b1100110;
				4'h5:		Temp_r = 7'b1101101;
				4'h6:		Temp_r = 7'b1111101;
				4'h7:		Temp_r = 7'b0000111;
				4'h8:		Temp_r = 7'b1111111;
				4'h9:		Temp_r = 7'b1101111;
				4'hA:		Temp_r = 7'b1110111;
				4'hB:		Temp_r = 7'b1111100;
				4'hC:		Temp_r = 7'b0111001;
				4'hD:		Temp_r = 7'b1011110;
				4'hE:		Temp_r = 7'b1111001;
				4'hF:		Temp_r = 7'b1110001;
				default:	Temp_r = 7'b0000000;
			endcase
		else
			Temp_r = 0;
	end
	
	// If the display has common anode then invert segment bits
	assign Segments_o = COMMON_CATHODE ? Temp_r : ~Temp_r;
	
endmodule
`default_nettype wire
